package com.qmth.teachcloud.report.business.service;

import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

/**
 * @Description: 课程单元操作服务类（课程删除、以课程为单位的改名操作）
 * @Author: CaoZixuan
 * @Date: 2022-02-25
 */
public interface CourseUnitOperateService {

    /**
     * 演示用变更基础课程名
     *
     * @param file     文件
     * @param schoolId 学校id（检测器）
     * @return 结果
     */
    String changeBasicCourse(MultipartFile file, Long schoolId) throws IOException, NoSuchFieldException;

    /**
     * 演示用变更系统机构名
     *
     * @param file     文件
     * @param schoolId 学校id（检测器）
     * @return 结果
     */
    String changeSysOrg(MultipartFile file, Long schoolId) throws IOException, NoSuchFieldException;

    /**
     * 演示用变更
     *
     * @param file     文件
     * @param schoolId 学校id（检测器）
     * @return 结果
     */
    String changeSysUser(MultipartFile file, Long schoolId) throws IOException, NoSuchFieldException;

    /**
     * 制作真实数据
     */
    void createDemoData();
}
