package com.qmth.teachcloud.report;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.qmth.boot.tools.signature.SignatureEntity;
import com.qmth.boot.tools.signature.SignatureType;
import com.qmth.teachcloud.common.config.DictionaryConfig;
import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.common.enums.ExceptionResultEnum;
import com.qmth.teachcloud.common.util.HttpUtil;
import com.qmth.teachcloud.report.business.entity.TBCloudExam;
import com.qmth.teachcloud.report.business.enums.PublishStatusEnum;
import com.qmth.teachcloud.report.business.service.AnalyzeForReportService;
import org.apache.commons.lang3.StringEscapeUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.*;

/**
 * @Description:
 * @Author: CaoZixuan
 * @Date:
 */
@SpringBootTest(classes = {TeachcloudReportApplication.class})
@RunWith(SpringRunner.class)
public class AnalyzeForStudentServiceTest {
    @Resource
    private AnalyzeForReportService analyzeForReportService;
    @Resource
    DictionaryConfig dictionaryConfig;


    @Test
    public void buildAnalyzeExamCourse() {
        Long examId = 2L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzeExamCourse(examId,courseCode));

    }

    @Test
    public void buildAnalyzeExamCourseRecord() {
        Long examId = 1L;
        String courseCode = "1013";
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseRecord(examId,courseCode));
    }

    @Test
    public void buildAnalyzeExamCourseCollegeInspectByOther() {
        Long examId = 1L;
        String courseCode = "1013";
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseCollegeInspect(examId,courseCode));
    }

    @Test
    public void buildAnalyzeExamCourseClazz() {
        Long examId = 1L;
        String courseCode = "1013";
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseClazz(examId,courseCode));
    }

    @Test
    public void analyzePointScoreRate() throws Exception {
        Long examId = 1L;
        String courseCode = "1013";
        analyzeForReportService.buildAnalyzePointScoreRate(examId,courseCode);
    }

    @Test
    public void buildAnalyzeExamCourseCollegeInspectDio() {
        Long examId = 1L;
        String courseCode = "1013";
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseCollegeInspectDio(examId,courseCode));
    }

    @Test
    public void buildAnalyzePaperStruct() {
        Long examId = 1L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzePaperStruct(examId,courseCode));
    }

    @Test
    public void buildExamPaperDifficult(){
        Long examId = 1L;
        System.out.println(analyzeForReportService.buildExamPaperDifficult(examId,null));
    }

    @Test
    public void buildExamPaperTeacherDifficult(){
        Long examId = 1L;
        System.out.println(analyzeForReportService.buildExamPaperTeacherDifficult(examId,null));
    }

    @Test
    public void buildAnalyzeExamTotal() {
        Long examId = 1L;
        System.out.println(analyzeForReportService.buildAnalyzeExamTotal(examId));
    }

    @Test
    public void buildAnalyzeExamCourseCollegeTeacher() {
        Long examId = 2L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseCollegeTeacher(examId,courseCode));
    }

    @Test
    public void buildAnalyzeExamCourseTeacher() {
        Long examId = 1L;
        String courseCode = "1013";
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseTeacher(examId,courseCode));
    }

    @Test
    public void temp(){
        Long examId = 1L;
        analyzeForReportService.buildAnalyzeExamCourseTeacherDio(examId,null);
        analyzeForReportService.buildExamPaperTeacherDifficult(examId,null);
    }

    @Test
    public void buildDifficult(){
        Long examId = 1L;
        String courseCode = null;
        analyzeForReportService.buildExamPaperDifficult(examId,courseCode);
        analyzeForReportService.buildExamPaperTeacherDifficult(examId,courseCode);
    }




    @Test
    public void finishCalculate(){
        Long examId = 1L;
        String courseCode = "1013";
        System.out.println(analyzeForReportService.updateCoursePublishStatus(examId,courseCode, PublishStatusEnum.WILL_COMPUTE));
    }

    @Test
    public void buildAnalyzeExamCourseTeacherCollegeDio(){
        Long examId = 2L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseTeacherCollegeDio(examId,courseCode));
    }

    @Test
    public void buildAnalyzeExamCourseTeacherCollegeDifficult(){
        Long examId = 2L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzeExamCourseTeacherCollegeDifficult(examId,courseCode));
    }

    @Test
    public void buildAnalyzeCollegePaperStruct(){
        Long examId = 1L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzeCollegePaperStruct(examId,courseCode));
    }

    @Test
    public void buildAnalyzeTeacherPaperStruct(){
        Long examId = 2L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzeTeacherPaperStruct(examId,courseCode));
    }

    @Test
    public void buildAnalyzeTeacherCollegePaperStruct(){
        Long examId = 2L;
        String courseCode = null;
        System.out.println(analyzeForReportService.buildAnalyzeTeacherCollegePaperStruct(examId,courseCode));
    }

    @Test
    public void syncCloudExam() throws IOException {
        // 三个参数
        Long examId = 263L;
        String accessKey = "a8599fce46fd4e0192d2d13c7b258931";
        String accessSecret = "Sl9xiXAphY04eE8ojuTqRgcv";

        String url = dictionaryConfig.yunMarkDomain().getUrl() + dictionaryConfig.yunMarkDomain().getStudentScoreApi();
        Map<String, Object> params = new HashMap<>();
        params.put("examId", examId);


        int pageNumber = 1;
        int pageSize = 100;
        List<Map> students = null;
        for (; ; ) {
            params.put("pageNumber", pageNumber);
            params.put("pageSize", pageSize);
            Long timestamp = System.currentTimeMillis();
            String accessToken = SignatureEntity.build(SignatureType.SECRET, SystemConstant.METHOD, dictionaryConfig.yunMarkDomain().getStudentScoreApi(), timestamp, accessKey, accessSecret);
            String result = HttpUtil.post(url, params, accessToken, timestamp);
            result = StringEscapeUtils.unescapeHtml4(result);
            if (Objects.nonNull(result)) {
                if (result.contains("HTTP")) {
                    throw ExceptionResultEnum.ERROR.exception("云阅卷鉴权失败");
                }
                List<Map> tempList = JSONObject.parseArray(JSONObject.toJSON(result).toString(), Map.class);
                if (Objects.nonNull(tempList) && tempList.size() > 0) {
                    if (Objects.isNull(students)) {
                        students = new ArrayList<>();
                    }
                    students.addAll(tempList);
                    pageNumber++;
                } else {
                    break;
                }
            } else {
                break;
            }
        }
        System.out.println(JSON.toJSONString(students));
    }
}
