package com.qmth.teachcloud.report.report;

import com.qmth.teachcloud.report.TeachcloudReportApplication;
import com.qmth.teachcloud.report.business.service.CourseUnitOperateService;
import org.apache.commons.io.IOUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.scheduling.annotation.Async;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

/**
 * @Description: 课程单元演示制作测试类
 * @Author: CaoZixuan
 * @Date: 2022-03-01
 */
@SpringBootTest(classes = {TeachcloudReportApplication.class})
@RunWith(SpringRunner.class)
public class CourseUnitOperateServiceTest {
    @Resource
    private CourseUnitOperateService courseUnitOperateService;

    private MultipartFile transferFtoM(File file) throws IOException {
        FileInputStream input = new FileInputStream(file);
        return new MockMultipartFile("file", file.getName(), "text/plain", IOUtils.toByteArray(input));
    }

    @Test
    public void testChangeBasicCourse() throws IOException, NoSuchFieldException {
        File file = new File("C:\\Users\\ASUS\\Desktop\\教研分析演示文件\\基础课程文件.xlsx");
        MultipartFile m = this.transferFtoM(file);
        Long schoolId = 2L;
        System.out.println(courseUnitOperateService.changeBasicCourse(m, schoolId));
    }

    @Test
    public void testChangeSysOrg() throws IOException, NoSuchFieldException {
        File file = new File("C:\\Users\\ASUS\\Desktop\\教研分析演示文件\\机构文件.xlsx");
        MultipartFile m = this.transferFtoM(file);
        Long schoolId = 2L;
        System.out.println(courseUnitOperateService.changeSysOrg(m, schoolId));
    }

    @Test
    public void testChangeSysUser() throws IOException, NoSuchFieldException {
        File file = new File("C:\\Users\\ASUS\\Desktop\\教研分析演示文件\\用户文件.xlsx");
        MultipartFile m = this.transferFtoM(file);
        Long schoolId = 2L;
        System.out.println(courseUnitOperateService.changeSysUser(m, schoolId));
    }

    @Test
    public void testCreateDemoData() {
        courseUnitOperateService.createDemoData();
    }

    @Async
    public void sout10() throws InterruptedException {
        for (int i = 0; i < 10; i++) {
            System.out.println(10);
            Thread.sleep(10);
        }
    }

    @Async
    public void sout20() throws InterruptedException {
        for (int i = 0; i < 10; i++) {
            System.out.println(20);
            Thread.sleep(10);
        }
    }

    @Test
    public void soutTest() throws InterruptedException {
        Long b = System.currentTimeMillis();
        this.sout10();
        this.sout20();
        Long e = System.currentTimeMillis();
        System.out.println(e - b);
    }
}
